//
// Callnative.java : JDK  Java 饹갷ؿ 
//                      (import ǥɲǽʳĥѥå)
//
//              This is a part of miolisp sourcefile
//              Copyright (C) 1998  Nishiyama, Naoki / Mio software lab. 
//
//  This program is free software; you can redistribute it and/or modify
//  it under the terms of the GNU General Public License as published by
//  the Free Software Foundation; either version 2 of the License, or
//  (at your option) any later version.
//
//  This program is distributed in the hope that it will be useful,
//  but WITHOUT ANY WARRANTY; without even the implied warranty of
//  MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
//  GNU General Public License for more details.
//
//  You should have received a copy of the GNU General Public License
//  along with this program; if not, write to the Free Software
//  Foundation, Inc., 59 Temple Place, Suite 330, Boston, MA  02111-1307  USA
//

import java.util.* ;
import java.awt.* ;
import java.awt.event.* ;
import java.io.* ;

public final class Callnative implements LispFunction {
  // JavaNull (Java  null ֤)
  public static Object Javanull(Environment e,Object o) throws Exception {
    return null ;
  }

  // Javanullp (Java  null ɤȽ)
  public static Object JavanullP(Environment e,Object o) throws Exception {
    o = Eval.eval(Evalutil.getarg1("classname :",o),e) ;
    return (o == null ? SAtom.t : SAtom.nil) ;
  }

  // Native (Java Method,Constructor ֥Ȥ)
  public static Object Native(Environment e,Object o) throws Exception {
    ListIter i = new ListIter(o) ;
    Object cname  = i.getNextObjEval("native",e) ;
    Object mname  = i.getNextObjEval("native",e) ;
    Object argtyp = i.getRestEval("native",e) ;
    return GetNative.getmethod(cname,mname,argtyp) ;
  }

  // Classname
  public static Object Classname(Environment e,Object o) throws Exception {
    o = Eval.eval(Evalutil.getarg1("classname :",o),e) ;
    return o.getClass().getName() ;
  }

  // isInstanceof
  public static Object isInstanceOf(Environment e,Object o) throws Exception {
    ListIter i = new ListIter(o) ;
    Object a,d ;
    a = i.getNextObjEval("isinstanceof",e) ;
    d = i.getFinalObjEval("isinstanceof",e) ;
    return (a.getClass().getName().equals(d) ? SAtom.t : SAtom.nil) ; 
  }

  // getActionListener
  public static Object getActionListener(final Environment e,Object o) throws Exception {
    final Object u = Eval.eval(Evalutil.getarg1("getactionlistener :",o),e) ;

    class myActionListener implements ActionListener {     
      public void actionPerformed(ActionEvent ae) {
        // apply ^^;
        //  (*δؿ* *Event Object*) Ȥ
        //  ꥹȤ򥳡Хå줿Ǻ
        //  ꥹʡδĶɾƤ롣
        Cons tpl = new Cons(u,new Cons(
                   new Cons(SAtom.quote,new Cons(ae,SAtom.nil)),SAtom.nil)) ;
        try { Eval.eval(tpl,e) ; } catch (Exception ex) {}
      }
    }

    return new myActionListener() ;
  }


  // getKeyListener
  public static Object getKeyListener(final Environment e,Object o) throws Exception {
    final Object u = Eval.eval(Evalutil.getarg1("getkeylistener :",o),e) ;

    class myKeyListener implements KeyListener {
      public void keyPressed(KeyEvent ke) { keyaction(1,ke) ; }
      public void keyReleased(KeyEvent ke) { keyaction(2,ke) ; }
      public void keyTyped(KeyEvent ke) { keyaction(3,ke) ; }
      public void keyaction(int i,KeyEvent ke) {
        // apply ^^;
        //  (*δؿ* *Event Object*) Ȥ
        //  ꥹȤ򥳡Хå줿Ǻ
        //  ꥹʡδĶɾƤ롣
        Cons tpl = new Cons(u,new Cons(
                   new Cons(SAtom.quote,new Cons(ke,SAtom.nil)),SAtom.nil)) ;
        try { Eval.eval(tpl,e) ; } catch (Exception ex) {}
      }
    }

    return new myKeyListener() ;
  }

  // Sleep
  public static Object sleep(Environment e,Object o) throws Exception {
    o = Eval.eval(Evalutil.getarg1("sleep :",o),e) ;
    if (o instanceof Number) {
      Thread.sleep(((Number)o).intValue()) ;
      return SAtom.t ;
    }
    throw new EvalException("sleep : not a Number") ;
  }

}

