//
// Environment.java : Ķ
//
//              This is a part of miolisp sourcefile
//              Copyright (C) 1998  Nishiyama, Naoki / Mio software lab. 
//
//  This program is free software; you can redistribute it and/or modify
//  it under the terms of the GNU General Public License as published by
//  the Free Software Foundation; either version 2 of the License, or
//  (at your option) any later version.
//
//  This program is distributed in the hope that it will be useful,
//  but WITHOUT ANY WARRANTY; without even the implied warranty of
//  MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
//  GNU General Public License for more details.
//
//  You should have received a copy of the GNU General Public License
//  along with this program; if not, write to the Free Software
//  Foundation, Inc., 59 Temple Place, Suite 330, Boston, MA  02111-1307  USA
//

import java.util.* ;

class Environment implements Cloneable {
  public static final int ENTRIES = 12 ;
  public static final String JAVANULL = "*JAVANULL*" ; 

  Vector dics ;
  Environment()                  { dics = new Vector() ; }
  Environment(Vector defaultdic) { dics = defaultdic ; }
  void addNewDic(Hashtable h)    { dics.addElement(h) ; }

  // ֥ơ֥Υפ֤()
  Environment __getLocalVars() throws CloneNotSupportedException {
    Environment ne = null ;
    if (!dics.isEmpty()) { // ѿȤΤߺ
      ne = new Environment() ;
      // ƬɲäƤ椯
      for (int i=0; i < dics.size() ;i++)
        ne.addNewDic((Hashtable)((Hashtable)dics.elementAt(i)).clone()) ;
    }
    return ne ;
  }

  // ִĶΥԡפ֤δؿءʤϤ(¿ʬ)
  Environment getLocalVars() throws CloneNotSupportedException {
    Environment ne = null ;
    if (!dics.isEmpty()) { // ѿȤΤߺ
      ne = new Environment((Vector)this.dics.clone()) ;
    }
    return ne ;
  }

  // μäʴĶ֤(ơ֥뼫ȤƱ)
  Environment getNewDic(Environment e) throws CloneNotSupportedException {
    Environment ne = new Environment((Vector)this.dics.clone()) ;
    if (e != null) {
      // ɲäƤ椯
      for (int i=0 ;i < e.dics.size() ;i++) 
        ne.addNewDic((Hashtable)e.dics.elementAt(i)) ;
    }
    return ne ;
  }

  // 򻲾Ȥ
  Object lookup(SAtom s) {
    Object res = null ;
    for (int i = dics.size()-1 ; (res == null) && (i >= 0) ; i--) {
      res = ((Hashtable)dics.elementAt(i)).get(s) ;
    }
    // ͤλ
    if (res == null) res = s.getGlobal() ;
    if (res == JAVANULL) res = null ; // null 갷Υ
    return res ;
  }

  // ߤδĶ«
  void bind(SAtom s,Object m) {
    Hashtable h ;
    if (m == null) m = JAVANULL ; // null 갷Υ
    for (int i = dics.size()-1 ; i >= 0 ; i--) {
      h = (Hashtable)dics.elementAt(i) ;
      if (h.containsKey(s)) {
        h.put(s,m) ;
        return ;
      }     
    }
    s.setGlobal(m) ; // ͤؤ
  } 

  // 뼭ɽ
  void printDics() {
    System.out.println(Sexpr.toStr(getlist(dics.elements()))) ; 
    System.out.println("-------------------------------------") ;
  }

  // ĶΤ alist ΥꥹȤȤ
  public Object toalist() { return getlist(dics.elements()) ; }

  // ĶΤ alist ΥꥹȤȤ()
  private Object getlist(Enumeration e) {
    if (e.hasMoreElements()) {
      Hashtable h = (Hashtable)e.nextElement() ;
      return new Cons(getdicalist(h,h.keys()),getlist(e)) ; 
    }
    return SAtom.nil ;
  }

  // (ϥåơ֥) lisp ϢۥꥹȤȤ()
  public static Object getdicalist(Hashtable h,Enumeration e) {
    if (e.hasMoreElements()) {
      Object o = e.nextElement() ;
      return new Cons(new Cons(o,h.get(o)),getdicalist(h,e)) ; 
    }
    return SAtom.nil ;
  }
}
