//
// Eval.java : Lisp ɾ
//
//              This is a part of miolisp sourcefile
//              Copyright (C) 1998  Nishiyama, Naoki / Mio software lab. 
//
//  This program is free software; you can redistribute it and/or modify
//  it under the terms of the GNU General Public License as published by
//  the Free Software Foundation; either version 2 of the License, or
//  (at your option) any later version.
//
//  This program is distributed in the hope that it will be useful,
//  but WITHOUT ANY WARRANTY; without even the implied warranty of
//  MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
//  GNU General Public License for more details.
//
//  You should have received a copy of the GNU General Public License
//  along with this program; if not, write to the Free Software
//  Foundation, Inc., 59 Temple Place, Suite 330, Boston, MA  02111-1307  USA
//

import java.util.* ;
import java.lang.reflect.* ;

public class Eval {
  // ɾ
  public static Object eval(Object s,Environment e) throws Exception {
    // Atom 
    if (s instanceof Atom) return ((Atom)s).eval(e) ;

    // 󥹤
    if (s instanceof Cons) return evalcons(s,e) ;

    // ʸ󤫡
    if (s instanceof String) return s ;

    // ͤ
    if (s instanceof Number) return s ;

    throw new EvalException("eval : <"+s+"> Unknown Object") ;
  }

  public static Object evalcons(Object s,Environment e) throws Exception {
    Object ca = ((Cons)s).car , cd = ((Cons)s).cdr ; 

    if (ca instanceof SAtom) {
      ca = ((SAtom)ca).eval(e) ;
    } else if (ca instanceof Cons) { // ((lambda () ... on 1st arg etc....
      ca = eval(ca,e) ;
    } 

// ---- ʳ ca ˤ Method  Macro ʤϤ

    // Lisp ؿ(lambda()) ޥ(macro())֥Ȥν
    if (ca instanceof Macro) {
      return ((Macro)ca).eval(cd,e) ;
    }

    //  Java ᥽åɥ֥Ȥν
    if (ca instanceof NativeFunction) {
      // LispFunction 󥿥ե (static method only)
      //   ((native ...) arg1 arg2 ....) with environment
      //   --> Object lispfunc(Environment,(arg1 arg2)) ;
      Method m = ((NativeFunction)ca).m ;
      Object[] o = new Object[2] ;
      o[0] = e ; o[1] = cd ;
      try {
        return m.invoke(null,o) ;
      } catch(InvocationTargetException ex) {
        throw (Exception)ex.getTargetException() ;
      }
    }

    // Java ᥽åɥ֥Ȥν
    if (ca instanceof Method) {
      Method m = (Method)ca ;
      Cons c = Evalutil.mustbecons("JavaMethod :",cd) ;
      // Java ɸ class (static and instance method)
      //   ((native ...) *dummy* arg1 arg2 ....) static method call
      //   ((native ...) obj  arg1 arg2 ....) instance method call
      //   --> ???? obj.javafunc(arg1,arg2)
      try {
        Object args = Evalutil.evalall(-1,-1,c.cdr,e) ;
        return m.invoke(Eval.eval(c.car,e),Evalutil.listtoarg(args)) ;
      } catch(InvocationTargetException ex) {
        throw (Exception)ex.getTargetException() ;
      }
    } 

    // Java 󥹥ȥ饯֥Ȥν
    if (ca instanceof Constructor) {
      try {
        Object args = Evalutil.evalall(-1,-1,cd,e) ;
        return ((Constructor)ca).newInstance(Evalutil.listtoarg(args)) ;
      } catch(InvocationTargetException ex) {
        throw (Exception)ex.getTargetException() ;
      }
    } 

    // JavaMethod ֥Ȥν
    if (ca instanceof JavaMethod) {
      Cons c = Evalutil.mustbecons("JavaMethod :",cd) ;
      return ((JavaMethod)ca).eval(new Cons(Eval.eval(c.car,e),c.cdr),e) ;
    }

    // (obj "Method" args.... ɤå
    if (cd instanceof Cons) {
      Cons c = (Cons)cd ;
      if (c.car instanceof String) {
        String ss = ca.getClass().getName()+"."+((String)c.car) ;
        Object o = SAtom.getSAtom(ss).eval(e) ;
        if (o instanceof JavaMethod) {
          Cons cc = new Cons(ca,c.cdr) ;
          return ((JavaMethod)o).eval(cc,e) ;
        }
      }
    }

    // 顼
    throw new EvalException("evalcons : <"+ca+"> Unknown Object") ;
  }
}

