//
// Macro.java : Lisp Macro ֥ȥ饹
//
//              This is a part of miolisp sourcefile
//              Copyright (C) 1998  Nishiyama, Naoki / Mio software lab. 
//
//  This program is free software; you can redistribute it and/or modify
//  it under the terms of the GNU General Public License as published by
//  the Free Software Foundation; either version 2 of the License, or
//  (at your option) any later version.
//
//  This program is distributed in the hope that it will be useful,
//  but WITHOUT ANY WARRANTY; without even the implied warranty of
//  MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
//  GNU General Public License for more details.
//
//  You should have received a copy of the GNU General Public License
//  along with this program; if not, write to the Free Software
//  Foundation, Inc., 59 Temple Place, Suite 330, Boston, MA  02111-1307  USA
//

import java.util.* ;

class LambdaArg {
  public static final String AUXSTR  = "&aux"  ;   // &aux keyword
  public static final String RESTSTR = "&rest" ;   // &rest keyword 
  public static SAtom aux , rest ;

  static {
    aux  = SAtom.getSAtom(AUXSTR) ;
    rest = SAtom.getSAtom(RESTSTR) ;
  }
}

public class Macro {
  public Environment ec = null ;   // γĶ (Closure)
  public Object[] arg ;            // ꥹ
  public int minargs,maxargs ;     // Ǿ
  public Object   body ;           // 

  Macro(Environment ev,Object a,Object b) throws Exception {
    int i = 0 ;
    body  = b ;
    arg   = Evalutil.listtoarg(a) ;

    for (i=0;i<arg.length;i++) {
      Evalutil.mustbesatom("lambda.arglist :",arg[i]) ;
      if (arg[i] == LambdaArg.aux) break ;
      if (arg[i] == LambdaArg.rest) { minargs = i+1 ; maxargs = -1 ; break ; }
      maxargs = i+1 ; maxargs = i+1 ;
    }
  }

  // ol Ǽ륷ܥꥹȤˡꥹ o «
  static Hashtable bindlist(int size,Object[] ol,Object o) throws Exception {
    final int SIZEFACTOR = 3 ;
    Cons c ;
    boolean auxf = false ;
    Hashtable h = new Hashtable(size*SIZEFACTOR) ;

    for (int i=0;i<ol.length;i++) {
      // &aux 
      if (ol[i] == LambdaArg.aux) {
        auxf = true ;
        continue ;
      }

      // &rest 
      if (ol[i] == LambdaArg.rest) {
        h.put(ol[i+1],o) ; // null ϤȤꤢͤʤȤˤ롣
        i+=2 ;
        continue ; // &aux 뤫⤷ʤΤ
      }

      Object a ;
      if (!auxf) {
        c = Evalutil.mustbecons("lambda :",o) ;
        a = c.car ;
        o = c.cdr ;
      } else {
        a = SAtom.nil ;
      }
      //System.out.println("Binding "+Sexpr.toStr(ol[i])+" <- "+Sexpr.toStr(a)) ;
      h.put(ol[i],(a == null ? Environment.JAVANULL : a)) ;
    }
    return h ;
  }

  public Object eval(Object a,Environment e) throws Exception {
    Evalutil.argchk(minargs,maxargs,a) ;

    // Macro  2 ɾ
    Environment env = e.getNewDic(ec) ; // Macro ξ ec == null      
    if (arg.length > 0) {
      Hashtable h = bindlist(arg.length,arg,a) ;
      env.addNewDic(h) ;                  // «
    }
    Object o1 = Evalutil.evprogn(body,env) ;
    //System.out.println("MacroExpand ->"+Sexpr.toStr(o1)) ;
    return Eval.eval(o1,e) ; // ܤɾϡȤδĶǹԤȤա
  }
}


