//
// SAtom.java : ܥ Atom 饹
//
//              This is a part of miolisp sourcefile
//              Copyright (C) 1998,99  Nishiyama, Naoki / Mio software lab. 
//
//  This program is free software; you can redistribute it and/or modify
//  it under the terms of the GNU General Public License as published by
//  the Free Software Foundation; either version 2 of the License, or
//  (at your option) any later version.
//
//  This program is distributed in the hope that it will be useful,
//  but WITHOUT ANY WARRANTY; without even the implied warranty of
//  MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
//  GNU General Public License for more details.
//
//  You should have received a copy of the GNU General Public License
//  along with this program; if not, write to the Free Software
//  Foundation, Inc., 59 Temple Place, Suite 330, Boston, MA  02111-1307  USA
//

import java.util.* ;

// Symbol Atom
final class SAtom implements Atom {
  public static final String NILSTR     = "nil" ;
  public static final String TSTR       = "t" ;
  public static final String COMMASTR   = "comma" ;
  public static final String COMMAATSTR = "atmark" ;
  public static final String QUOTESTR   = "quote" ;
  public static final String BQSTR      = "backquote" ;

  // ͤʤ򼨤Υݥ󥿡ƤϤʤǤ褤
  public static final String NOVALUE    = "*NOVALUE*" ; 


  // ܥơ֥ν
  public static final int GLOBALENTRIES = 4096 ; 

  // ɤȤͭɽؤΥå
  public static SAtom nil , t , comma , commaat , quote , bquote ;

  // Ƥ Symbol ؤΥե󥹤ĥơ֥
  static Hashtable h = new Hashtable(GLOBALENTRIES) ;

  // 󥹥ѿ
  Object prop ; // °ꥹ(̤)
  Object glob ; //  
  String s ;    // ̾

  static {
    nil        = getSAtom(NILSTR) ; 
    t          = getSAtom(TSTR) ; 
    comma      = getSAtom(COMMASTR) ;
    commaat    = getSAtom(COMMAATSTR) ;
    bquote     = getSAtom(BQSTR) ;
    quote      = getSAtom(QUOTESTR) ;
  }
 
  // ܥñݻΤᡢ󥹥ȥ饯 getSAtom Ȥ
  public static SAtom getSAtom(String x) {
    x = x.toLowerCase() ;
    SAtom s = (SAtom)h.get(x) ;
    if (s == null) { // ϿƤʤ
      s = new SAtom(x) ;
      h.put(x,s) ;
    }
    return s ;
  }

  // 饳󥹥ȥ饯ϸƤ٤ʤ褦ˤʤäƤ롣
  private SAtom(String x) { s = x ; prop = nil ; glob = NOVALUE ; }
  public String getName() { return s ; }
  public boolean nullp() { return this == nil ; }
  public boolean eq(Atom x) { return this == x ; }

  // ͤ
  public void setGlobal(Object o) { glob = o ;}

  // ͤ
  public Object getGlobal() { return glob ; }

  // 
  public Object eval(Environment e) throws EvalException { 
    // nil  t ϸ
    if ((this == nil) || (this == t)) { return this ;}

    // Environment.lookup()  SAtom.getGlobal() Ƥ֤롣
    Object res = e.lookup(this) ; 
    if (res == NOVALUE) {
      throw new EvalException("Symbol <"+s+"> not defined") ;
    }
    return res ; 
  }

  // Х뼭ϢۥꥹȤȤ
  static Object getGlobalDic() {
    return getgdicalist(h.elements()) ;
  }

  // Х뼭(ϥåơ֥) lisp ϢۥꥹȤȤ
  private static Object getgdicalist(Enumeration e) {
    if (e.hasMoreElements()) {
      SAtom s = (SAtom)e.nextElement() ;
      if (s.glob != NOVALUE) { // ͤͭΤΤ    
        return new Cons(new Cons(s,s.glob),getgdicalist(e)) ;
      } else {
        return getgdicalist(e) ;
      } 
    }
    return SAtom.nil ;
  }
}


