//
// Sexpr.java : S ɽ
//
//              This is a part of miolisp sourcefile
//              Copyright (C) 1998  Nishiyama, Naoki / Mio software lab. 
//
//  This program is free software; you can redistribute it and/or modify
//  it under the terms of the GNU General Public License as published by
//  the Free Software Foundation; either version 2 of the License, or
//  (at your option) any later version.
//
//  This program is distributed in the hope that it will be useful,
//  but WITHOUT ANY WARRANTY; without even the implied warranty of
//  MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
//  GNU General Public License for more details.
//
//  You should have received a copy of the GNU General Public License
//  along with this program; if not, write to the Free Software
//  Foundation, Inc., 59 Temple Place, Suite 330, Boston, MA  02111-1307  USA
//

class Sexpr {
  // S ɽ  
  public static String toStr(Object x) { return toStr2(x,false) ; }

  static String toStr2(Object x,boolean iscdr) {
    if (x instanceof Atom) {
      Atom a = (Atom)x ;
      String s = a.getName() ;
      if (iscdr) return (a.nullp() ? ")" : " . " + s + ")") ;
      return s ;
    }
    if (x instanceof Cons) {
      Cons c = (Cons)x ; 
      return (iscdr ? " " : "(") + toStr2(c.car,false) + toStr2(c.cdr,true) ;
    }
    if (x instanceof String) {
      return (iscdr ? " . " : "") + (char)Sreader.STRTERMCHAR +
             x + (char)Sreader.STRTERMCHAR + (iscdr ? ")" : "") ;
    }
    if (x instanceof Number) {
      return (iscdr ? " . " : "") + x + (iscdr ? ")" : "") ;
    }
    return (iscdr ? " . " : "") + 
           "#<javaobject : "+x+">" + (iscdr ? ")" : "");
  }
}



