;; loading classes
(import "Primitive")
(import "Callnative")

;; defun 
(define defun
   (macro (name arglist &rest body) 
         `(define ,name (lambda ,arglist ,@body))))

;; defmacro
(define defmacro
   (macro (name arglist &rest body)
         `(define ,name (macro ,arglist ,@body))))

;; new
(defun new (cname) 
  ((native cname "new")))

;; Get method objects to Using "java.util.Hashtable"
(define hashtable.put 
  (native "java.util.Hashtable" "put" "java.lang.Object" "java.lang.Object"))
(define hashtable.get
  (native "java.util.Hashtable" "get" "java.lang.Object"))

;; Property List like thing using "java.util.Hashtable" ....
(define *plist* (new "java.util.Hashtable"))

(defun putprop (symbol value prop &aux stable)
  (setq stable (hashtable.get *plist* symbol))
  (cond ((javanullp stable) 
         (setq stable (new "java.util.Hashtable"))
         (hashtable.put *plist* symbol stable)))
  (hashtable.put stable prop value) value)

(defun get (symbol prop &aux stable)
  (setq stable (hashtable.get *plist* symbol))
  (cond ((javanullp stable) (javanull))
        (t (hashtable.get stable prop))))






