//
//  mylispApplet.java : ץå Miolisp Toplevel
//
//              This is a part of miolisp sourcefile
//              Copyright (C) 1998  Nishiyama, Naoki / Mio software lab. 
//
//  This program is free software; you can redistribute it and/or modify
//  it under the terms of the GNU General Public License as published by
//  the Free Software Foundation; either version 2 of the License, or
//  (at your option) any later version.
//
//  This program is distributed in the hope that it will be useful,
//  but WITHOUT ANY WARRANTY; without even the implied warranty of
//  MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
//  GNU General Public License for more details.
//
//  You should have received a copy of the GNU General Public License
//  along with this program; if not, write to the Free Software
//  Foundation, Inc., 59 Temple Place, Suite 330, Boston, MA  02111-1307  USA
//

import java.applet.Applet ;
import java.awt.* ;
import java.io.* ;
import java.net.* ;
import java.util.* ;

public class mylispApplet extends Applet
{
  Label title ;
  TextArea text ;
  TextField commandLine ;
  Button evalButton ;

  Environment env ;

  void initlsp() {
    env = new Environment() ;
    text.appendText("Mio Lisp Toplevel Interface (Applet Version - Experimantal)\n") ;
    text.appendText("Copyright (C) 1998  Nishiyama,Naoki / Mio software lab.\n") ;
    text.appendText("This is free software with ABSOLUTELY NO WARRANTY.\n") ;
    text.appendText("See the file COPYING for details.\n") ;

    // alternate of init.lsp
    GetNative.bindimport() ;
    try {
      GetNative.importlispclass("Primitive",env,false) ;
      GetNative.importlispclass("Callnative",env,false) ;
    } catch (Exception e) {
      e.printStackTrace() ;
      text.appendText("Can't loading Primitive Classes.. See 'Java Console' for detail...\n") ;
    }
  }

  public void init() {
    setBackground(Color.green) ;

    title = new Label("Mio Lisp - A small Lisp interpreter written in Java...");
    add(title) ;
    Panel p0 = new Panel();
    commandLine = new TextField(40) ;
    commandLine.setBackground(Color.white) ;
    p0.add(commandLine) ;

    evalButton = new Button("Eval") ;
    evalButton.setBackground(Color.white) ;
    p0.add(evalButton) ;

    Panel p3 = new Panel() ;
    p3.setLayout(new BorderLayout(10,10)) ;
    text = new TextArea(20,54) ;
    text.setEditable(false) ;
    text.setBackground(Color.white) ;
    p3.add("North",text) ;

    add(p3) ;
    add(p0) ;

    initlsp() ;
  }

  // I prefered 'DEPRECATED API' for some browser ;-)
  public boolean action(Event event,Object arg) {
    String res ;

    if ((event.target == evalButton) ||
        (event.target == commandLine)) {
      res = commandLine.getText() ;
      if (res != "") {
        try {
          text.appendText("miolisp>"+res+"\n") ;
          res = Sexpr.toStr(Evalutil.Evalstring(res,env)) ;
          commandLine.setText("") ;
        } catch(Exception e) {
          e.printStackTrace() ;
          res = "Exception Occured.. See 'Java Console' for detail..." ;
        }
        text.appendText(res+"\n") ;
      }
      return true ;
    }
    return false ;
  }
}



